#include "c_bitmap_factory.h"

c_bitmap_factory::c_bitmap_factory()
{
	m_p_bmphead = NULL;
}

c_bitmap_factory::~c_bitmap_factory()
{
	bmplist *p_bmplist = m_p_bmphead, *p_temp = NULL;
	
	// Destroy all bitmaps in the linked list and delete list nodes
	while (p_bmplist != NULL)
	{
		p_temp = p_bmplist;
		if (p_bmplist->p_bmp)
			destroy_bitmap(p_bmplist->p_bmp);
		p_bmplist = p_bmplist->p_next;
		delete p_temp;
	}
}

bool c_bitmap_factory::get_bitmap(string filename, BITMAP **pp_bmp)
{
	bool f_found = false, f_result = false;
	bmplist *p_bmpitem = NULL;
	
	// First see if the bitmap is already loaded
	p_bmpitem = m_p_bmphead;
	while (p_bmpitem != NULL)
	{
		if (p_bmpitem->filename == filename)
		{
			// This is the bitmap we're after, assign it and break
			*pp_bmp = p_bmpitem->p_bmp;
			f_found = true;
			f_result = true;
			break;
		}
		p_bmpitem = p_bmpitem->p_next;
	}
	
	// If the bitmap wasn't found, try to load it and then add it to the list
	if (!f_found)
	{
		p_bmpitem = new bmplist;
		if (p_bmpitem != NULL)
		{
			p_bmpitem->filename = filename;
			p_bmpitem->p_bmp    = load_bitmap(filename.c_str(), NULL);
			if (p_bmpitem->p_bmp != NULL)
			{
				// The bitmap was loaded, so add it to the list and assign it to pp_bmp
				p_bmpitem->p_next = m_p_bmphead;
				m_p_bmphead = p_bmpitem;
				*pp_bmp = p_bmpitem->p_bmp;
				f_result = true;
			}		
		}
	}
	
	return f_result;
}
