#include "c_music.h"

c_music::c_music()
{
	_init();
}

c_music::~c_music()
{
	// If the sample is loaded, stop it then destroy it
	if (m_sample != NULL)
	{
		stop();
		destroy_sample(m_sample);
		m_sample = NULL;
	}
}

void c_music::_init(void)
{
	m_sample = NULL;
}

bool c_music::load_wav_file(string filename)
{
	m_sample = load_sample(filename.c_str());
	return (m_sample != NULL);
}

void c_music::play(void)
{
	if (m_sample == NULL)
		return;
	play_sample(m_sample, 255, 128, 1000, 1);
}

void c_music::stop(void)
{
	if (m_sample == NULL)
		return;
	stop_sample(m_sample);
}
