#ifndef C_MUSIC_H
#define C_MUSIC_H

#include <allegro.h>
#include <string>

using namespace std;

/* Class: c_music
 * 
 * Encapsulates a single music track allowing basic control
 */
class c_music
{
private:
	SAMPLE *m_sample; // The Allegro sample
	
	void _init(void);
public:
	c_music();
	~c_music();
	
	/* Loads a RIFF Wave file
	 * Argument: -
	 *  - filename: the file name of the Wave file to load.
	 * Return: true if sample was loaded, false on failure.
	 */
	bool load_wav_file(string filename);
	
	/* Plays the track */
	void play(void);
	
	/* Stops the track if it's playing */
	void stop(void);
};

#endif
